package client

import (
	"fmt"
	"os/exec"
	"strings"
	"time"

	"github.com/aceld/zinx/ziface"
	"github.com/aceld/zinx/zlog"
	"github.com/aceld/zinx/znet"
)

type OpenNativeRenderRouter struct {
	znet.BaseRouter
}

func (*OpenNativeRenderRouter) PreHandle(request ziface.IRequest) {
	fmt.Println("client handle start...")
	zlog.Ins().DebugF("recv from client : msgId=%d, data=%+v, len=%d", request.GetMsgID(), string(request.GetData()), len(request.GetData()))
}

func (*OpenNativeRenderRouter) Handle(request ziface.IRequest) {
	// 获取roomId
	data := request.GetData()
	params := strings.Split(string(data), ":")
	if len(params) != 3 {
		zlog.Error("参数不正确")
		return
	}
	deviceId := params[0]
	roomId := params[1]
	url := params[2]
	// 下载url文件

	// TODO 将roomID 以参数形式传递给blender应用
	// blender中的客户端接收到房间和deviceId后发送创建nativeRender 消息
	// 打开后更新workdevice数据
	pid, err := openRenderFile("blender", []string{
		"-b",
		url,
		"--deviceId",
		deviceId,
		"--roomId",
		roomId,
	})
	fmt.Println(err)
	fmt.Println(pid)

}

func openRenderFile(cmdPath string, args []string) (int, error) {
	cmd := exec.Command(cmdPath, args...)

	// 运行命令并捕获输出
	err := cmd.Run()
	if err != nil {
		fmt.Printf("Blender 启动失败: %v\n", err)
		return -1, err
	}

	// 获取进程ID
	time.Sleep(3 * time.Second)
	pid := cmd.Process.Pid
	return pid, nil
}
